<template>
  <v-menu v-model="menu" :close-on-content-click="false">
    <template #activator="{ props }">
      <v-btn
        v-if="isAuth"
        append-icon="mdi-account"
        v-bind="props"
        color="green"
      >
        {{ userName }}
      </v-btn>
      <v-btn v-else icon v-bind="props">
        <v-icon icon="mdi-account"></v-icon>
      </v-btn>
    </template>
    <v-card v-if="!isAuth" min-width="300">
      <v-list>
        <v-list-item prepend-icon="mdi-login" title="Авторизация">
        </v-list-item>
      </v-list>
      <v-divider></v-divider>
      <v-list-item class="text-center my-3">
        <v-text-field v-model="authData.username" label="Логин" hide-details />
      </v-list-item>
      <v-list-item>
        <v-text-field v-model="authData.password" label="Пароль" hide-details />
      </v-list-item>
      <v-card-actions>
        <v-btn variant="tonal" dark block @click="loginHandler"> Войти </v-btn>
      </v-card-actions>
    </v-card>
    <v-card v-if="isAuth" min-width="300">
      <v-list>
        <v-list-item link="">
          Профиль
          <template #prepend>
            <v-btn
              color="grey-lighten-1"
              icon="mdi-account"
              variant="text"
            ></v-btn>
          </template>
        </v-list-item>
      </v-list>

      <v-card-actions>
        <v-btn variant="tonal" dark block @click="logoutHandler"> Выйти </v-btn>
      </v-card-actions>
    </v-card>
  </v-menu>
</template>

<script setup>
import { toRefs, ref } from 'vue'
import { dispatch } from 'vuex-pathify'

const props = defineProps({
  isAuth: {
    type: Boolean,
    default: () => false
  },
  userName: {
    type: String,
    default: () => 'userName'
  }
})
const { isAuth, userName } = toRefs(props)
const menu = ref(false)
const authData = ref({ username: 'kminchelle', password: '0lelplR' })
function menuHandler() {
  menu.value = false
}
function logoutHandler() {
  dispatch('user/logout', authData.value)
  menuHandler()
}
function loginHandler() {
  dispatch('user/login', authData.value)
  menuHandler()
}
</script>
